#lang s-exp "list-lang.rkt"

(provide all-remembered-list all-remembered-alist)

;; For older versions:
#|
(require/typed unstable/list
               [(group-by group-by-untyped)
                (∀ (A B) (->* [(→ A B) (Listof A)]
                              [(→ B B Any)]
                              (Listof (Listof A))))])

;; Circumvent problem with contracts: with the imported untyped version,
;; two identical keys are never equal?. I think this is because  the keys are
;; wrapped with contracts when they are passed to equal?, and therefore are not
;; equal?, because we're comparing two distinct contract wrappers, instead of
;; comparing their contents.
(: group-by (∀ (A B) (->* [(→ A B) (Listof A)]
                          [(→ B B Any)]
                          (Listof (Listof A)))))
(define (group-by key lst [same? equal?])
  (group-by-untyped key lst (λ ([x : B] [y : B]) (same? x y))))
|#

(define all-remembered-alist
  (map (λ ([g : (Listof (Pairof Symbol Any))]) : (Pairof Symbol (Listof Any))
         (cons (caar g) (remove-duplicates (map (inst cdr Symbol Any) g))))
       (group-by (inst car Symbol Any) all-remembered-list)))

(define-list-values all-remembered-list : (Listof (Pairof Symbol Any)))
;; All the items below are quoted and aggregated into all-remembered-list.
;; The lines below are automatically added by remember-lib.
(structure a b c)
(structure a b c d)
(structure a b c y)
(structure a b)
(structure x y z)
(structure)
(structure f g)
(structure faa fab fav)
(structure fba fbv)
(structure fav)
(structure a)
(structure a)
(structure people/with-promises-type streets/with-promises-type)
(structure houses/with-promises-type name/with-promises-type)
(structure location/with-promises-type owner/with-promises-type)
(structure name/with-promises-type)
(structure people streets)
(structure people streets)
(structure houses name)
(structure houses name)
(structure location owner)
(structure location owner)
(structure name)
(structure name)
(structure houses/with-promises-type sname/with-promises-type)
(structure houses sname)
(structure houses sname)
(structure f-a f-b)
(structure f-a f-b f-c)
(structure people)
(structure streets)
(structure location)
(structure streets)
(structure streets)
(structure x)
(structure x)
(structure x)
(structure sname)
(structure sname)
(structure sname)
(structure st)
(structure v)
(structure v)
(structure b1 b2 v)
(structure a s v)
(structure b1 b2 v)
(structure b1 b2 v)
(structure v w)
(structure v w)
(structure v w)
(structure b1 b2 s v)
(structure b1 b2 s v)
(structure b1 b2 s v)
(structure ab v)
(structure ba v)
(structure ab v)
(structure ab v)
(structure a c)
(structure a c)
(structure a1 s v)
(structure a1 s v)
(structure a1 s v)
(structure returned)
(structure returned)
(structure returned)
(structure returned)
(structure foo)
(structure foo)
(structure foo)
(structure foo)
(structure foo)
(structure foo)
(constructor . x)
(constructor . y)
(constructor . z)
(constructor . tagged-s1)
(constructor . tagged-s2)
(constructor . tagged-s3)
(constructor . tagged-s4)
(constructor . a)
(constructor . b)
(constructor . c)
(constructor . c)
(constructor . d)
(constructor . e)
(constructor . dd)
(constructor . ddd)
(constructor . dde)
(constructor . ddf)
(constructor . ddg)
(constructor . ddh)
(constructor . ddi)
(constructor . ddj)
(constructor . ddk)
(constructor . ddl)
(constructor . F)
(constructor . w)
(constructor . foo)
(constructor . foo)
(constructor . foo)
(constructor . de1)
(constructor . de2)
(constructor . de3)
(constructor . df3)
(constructor . df1)
(constructor . df2)
(structure Number String)
(structure Number String)
(structure Number String)
(constructor . dg1)
(constructor . dh1)
(constructor . dh1)
(constructor . dh1)
(constructor . di2)
(constructor . dj1)
(constructor . dk1)
(constructor . dl1)
(structure x y)
(constructor . txyz)
(constructor . City89/with-promises-tag)
(constructor . Street90/with-promises-tag)
(constructor . House91/with-promises-tag)
(constructor . Person92/with-promises-tag)
(structure n)
(structure water)
(structure water)
(constructor . cxyz)
(constructor . v)
(constructor . t1)
(constructor . Number)
(constructor . String)
(constructor . Number)
(constructor . c1)
(constructor . c2)
(constructor . c3)
(constructor . wrapped-structure)
(constructor . structure)
(constructor . structure)
(constructor . wstructure)
(constructor . wstructure)
(constructor . m-streets5/node)
(constructor . tabc)
(constructor . t)
(constructor . t)
(constructor . ma/incomplete)
(constructor . mb/incomplete)
(constructor . ma/incomplete)
(constructor . ma/incomplete)
(structure sym)
(structure err)
(structure sym)
(structure ctr water)
(structure ctr water)
(constructor . ma)
(constructor . mb)
(constructor . st2)
(structure f1a f2a)
(structure f1b)
(structure f1a f2a)
(structure f1b)
(structure f1a f2a)
